
package de.ivu.elect.presentation.gebietsbaum;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gebietsbaum.boundary.GebietsartConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartEdit;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsart;
import de.ivu.elect.business.gebietsbaum.entity.GebietsartMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractGebietsartEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractGebietsartEditNoScopeView.VIEW_ID, useCase = UseCasePermission.GEBIETSART_EDIT)
public abstract class AbstractGebietsartEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Gebietsart>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsartEditView";

  public static final String VIEW_ID = "/gebietsbaum/gebietsart-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/gebietsbaum/gebietsart-search.xhtml";

  @Inject
  protected transient GebietsartExtendedDAO extendedDAO;

  @Inject
  protected transient GebietsartEdit edit;

  @Inject
  @ConversationGroup(GebietsartConversationStore.class)
  protected transient GebietsartConversationStore conversationStore;

  @Inject
  protected transient GebietsartMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient GebietsartEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Gebietsart getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Gebietsart entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSART_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Gebietsart entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSART_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.GEBIETSART_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSART_EDIT)
  @Override
  public String save() {
    Gebietsart entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Gebietsart entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Gebietsart entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Gebietsart entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.GEBIETSART_EDIT);
  }
  
  @Redirect
  public String edit(Gebietsart entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class GebietsartEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Gebietsart,   de.ivu.elect.business.gebietsbaum.entity.GebietsartPK  > {

    private static final long serialVersionUID = 1L;
  }
}
